import { BinarySearchTreeTy, Comparator } from '../types';
export declare class BinarySearchTree<T> implements BinarySearchTreeTy<T> {
    private root;
    private comparator;
    constructor(comparator?: Comparator<T>);
    /**
     * Inserts a value into the BST
     */
    insert(value: T): void;
    /**
     * Searches for a value in the BST. Returns true if found, false otherwise
     */
    find(value: T): boolean;
    /**
     * Returns the minimum value in the BST, or undefined if tree is empty
     */
    min(): T | undefined;
    /**
     * Returns the maximum value in the BST, or undefined if tree is empty
     */
    max(): T | undefined;
    /**
     * Removes a value from the BST if it exists
     */
    remove(value: T): void;
    private removeNode;
    private findMin;
    private isEqual;
    /**
     * Returns true if the BST is empty, false otherwise
     */
    empty(): boolean;
    /**
     * Removes all nodes from the BST
     */
    clear(): void;
    /**
     * Returns the number of nodes in the BST
     */
    count(): number;
    private countNodes;
}
