import { RedBlackTreeTy, Comparator } from '../types';
export declare class RedBlackTree<K, V> implements RedBlackTreeTy<K, V> {
    private root;
    private nodeCount;
    private comparator;
    constructor(comparator?: Comparator<K>);
    private rotateLeft;
    private rotateRight;
    private fixInsert;
    insert(key: K, value: V): void;
    private findNode;
    find(key: K): V | undefined;
    private findMinNode;
    min(): V | undefined;
    private findMaxNode;
    max(): V | undefined;
    remove(key: K): void;
    private deleteNode;
    private transplant;
    private fixDelete;
    empty(): boolean;
    size(): number;
    clear(): void;
    private isEqual;
}
